#!/usr/bin/env python
import syslog
import nose_expected_failure as ef
import re
from time import sleep
import subprocess
import psycopg2
from datetime import datetime
from nose.tools import ok_

def test_destination_file():
    path = '/var/log/op5/logserver'

    now = datetime.now()
    filename = '%s/%s' % (path, now.strftime('%Y_%m_%d_%H'))

    # Clear the logfile
    subprocess.call('>%s' % filename, shell=True)

    syslog.syslog('test_destination_file')

    sleep(1)

    with open(filename, 'r') as f:
        for line in f:
            if re.match(r'.*test_destination_file.*', line, re.M|re.I):
                return
    f.closed
    ok_(False, 'Could not found string in logfile')

def test_destination_sql():
    try:
        conn = psycopg2.connect("dbname=op5lsu user=op5lsu")
    except:
        ok_(False, "Can't connect to db")

    now = datetime.now()
    table = 'messages_%s' % now.strftime('%Y_%m_%d_%H')

    # Make sure we don't bump into any timewarps
    subprocess.call('/opt/logserver/db/maintain_database.py', shell=True)

    cur = conn.cursor()
    cur.execute("truncate table %s;" % table)
    conn.commit()

    syslog.syslog('test_destination_sql')

    # We need this sleep because syslog-ng waits for 10k rows or 1 sec timeout
    # before commiting the content to db
    sleep(2)

    cur.execute("SELECT COUNT(*) FROM " + table + " WHERE msg LIKE '%test_destination_sql%';")
    test_destination = cur.fetchone()[0]
    cur.close()

    ok_(test_destination > 0, 'Could not find string in table: %s' % table)
